Index: /LMDZ5/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/physiq_mod.F90	(revision 2468)
+++ /LMDZ5/trunk/libf/phylmd/physiq_mod.F90	(revision 2469)
@@ -3214,1238 +3278,1248 @@
                    piz_aero_sw_rrtm(:,:,2,:)=piz_aero(:,:,2,:)
                    cg_aero_sw_rrtm (:,:,2,:)=cg_aero (:,:,2,:)
-           ELSE
-              abort_message='Only NSW=2 or 6 are possible with aerosols and iflag_rrtm=1'
-              call abort_physic(modname,abort_message,1)
-           ENDIF
-
-           CALL aeropt_lw_rrtm
-!
+                ELSE
+                   abort_message='Only NSW=2 or 6 are possible with ' &
+                        // 'aerosols and iflag_rrtm=1'
+                   call abort_physic(modname,abort_message,1)
+                ENDIF
+
+                CALL aeropt_lw_rrtm
+                !
 #else
-           abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-           call abort_physic(modname,abort_message,1)
+                abort_message='You should compile with -rrtm if running ' &
+                     // 'with iflag_rrtm=1'
+                call abort_physic(modname,abort_message,1)
 #endif
-              !
-           ENDIF
-        ENDIF
-     ELSE
-        tausum_aero(:,:,:) = 0.
-        IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-           tau_aero(:,:,:,:) = 1.e-15
-           piz_aero(:,:,:,:) = 1.
-           cg_aero(:,:,:,:)  = 0.
-        ELSE
-           tau_aero_sw_rrtm(:,:,:,:) = 1.e-15
-           tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
-           piz_aero_sw_rrtm(:,:,:,:) = 1.0
-           cg_aero_sw_rrtm(:,:,:,:)  = 0.0
-        ENDIF
-     ENDIF
-     !
-     !--STRAT AEROSOL
-     !--updates tausum_aero,tau_aero,piz_aero,cg_aero
-     IF (flag_aerosol_strat) THEN
-        IF (prt_level .GE.10) THEN
-         PRINT *,'appel a readaerosolstrat', mth_cur
-        ENDIF
-        IF (iflag_rrtm.EQ.0) THEN
-           CALL readaerosolstrato(debut)
-        ELSE
+                !
+             ENDIF
+          ENDIF
+       ELSE
+          tausum_aero(:,:,:) = 0.
+          IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+             tau_aero(:,:,:,:) = 1.e-15
+             piz_aero(:,:,:,:) = 1.
+             cg_aero(:,:,:,:)  = 0.
+          ELSE
+             tau_aero_sw_rrtm(:,:,:,:) = 1.e-15
+             tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
+             piz_aero_sw_rrtm(:,:,:,:) = 1.0
+             cg_aero_sw_rrtm(:,:,:,:)  = 0.0
+          ENDIF
+       ENDIF
+       !
+       !--STRAT AEROSOL
+       !--updates tausum_aero,tau_aero,piz_aero,cg_aero
+       IF (flag_aerosol_strat) THEN
+          IF (prt_level .GE.10) THEN
+             PRINT *,'appel a readaerosolstrat', mth_cur
+          ENDIF
+          IF (iflag_rrtm.EQ.0) THEN
+             CALL readaerosolstrato(debut)
+          ELSE
 #ifdef CPP_RRTM
-           CALL readaerosolstrato_rrtm(debut)
+             CALL readaerosolstrato_rrtm(debut)
 #else
 
-           abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-           call abort_physic(modname,abort_message,1)
+             abort_message='You should compile with -rrtm if running ' &
+                  // 'with iflag_rrtm=1'
+             call abort_physic(modname,abort_message,1)
 #endif
-        ENDIF
-     ENDIF
-     !--fin STRAT AEROSOL
-
-
-     !   On prend la somme des fractions nuageuses et des contenus en eau
-
-     if (iflag_cld_th>=5) then
-
-        do k=1,klev
-           ptconvth(:,k)=fm_therm(:,k+1)>0.
-        enddo
-
-        if (iflag_coupl==4) then
-
-           ! Dans le cas iflag_coupl==4, on prend la somme des convertures
-           ! convectives et lsc dans la partie des thermiques
-           ! Le controle par iflag_coupl est peut etre provisoire.
-           do k=1,klev
-              do i=1,klon
-                 if (ptconv(i,k).and.ptconvth(i,k)) then
-                    cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
-                    cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
-                 else if (ptconv(i,k)) then
-                    cldfra(i,k)=rnebcon(i,k)
-                    cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
-                 endif
-              enddo
-           enddo
-
-        else if (iflag_coupl==5) then
-           do k=1,klev
-              do i=1,klon
-                 cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
-                 cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
-              enddo
-           enddo
-
-        else
-
-           ! Si on est sur un point touche par la convection profonde et pas
-           ! par les thermiques, on prend la couverture nuageuse et l'eau nuageuse
-           ! de la convection profonde.
-
-           !IM/FH: 2011/02/23 
-           ! definition des points sur lesquels ls thermiques sont actifs
-
-           do k=1,klev
-              do i=1,klon
-                 if (ptconv(i,k).and. .not. ptconvth(i,k)) then
-                    cldfra(i,k)=rnebcon(i,k)
-                    cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
-                 endif
-              enddo
-           enddo
-
-        endif
-
-     else
-
-        ! Ancienne version
-        cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
-        cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
-     endif
-
-  ENDIF
-
-  !     plulsc(:)=0.
-  !     do k=1,klev,-1
-  !        do i=1,klon
-  !              zzz=prfl(:,k)+psfl(:,k)
-  !           if (.not.ptconvth.zzz.gt.0.)
-  !        enddo prfl, psfl,
-  !     enddo
-  !
-  ! 2. NUAGES STARTIFORMES
-  !
-  IF (ok_stratus) THEN
-     CALL diagcld2(paprs,pplay,t_seri,q_seri, diafra,dialiq)
-     DO k = 1, klev
-        DO i = 1, klon
-           IF (diafra(i,k).GT.cldfra(i,k)) THEN
-              cldliq(i,k) = dialiq(i,k)
-              cldfra(i,k) = diafra(i,k)
-           ENDIF
-        ENDDO
-     ENDDO
-  ENDIF
-  !
-  ! Precipitation totale
-  !
-  DO i = 1, klon
-     rain_fall(i) = rain_con(i) + rain_lsc(i)
-     snow_fall(i) = snow_con(i) + snow_lsc(i)
-  ENDDO
-  !IM
-  IF (ip_ebil_phy.ge.2) THEN 
-     ztit="after diagcld"
-     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
-          , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
-          , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(cell_area,ztit,ip_ebil_phy &
-          , zero_v, zero_v, zero_v, zero_v, zero_v &
-          , zero_v, zero_v, zero_v, ztsol &
-          , d_h_vcol, d_qt, d_ec &
-          , fs_bound, fq_bound )
-  END IF
-  !
-  ! Calculer l'humidite relative pour diagnostique
-  !
-  DO k = 1, klev
-     DO i = 1, klon
-        zx_t = t_seri(i,k)
-        IF (thermcep) THEN
-!!           if (iflag_ice_thermo.eq.0) then                 !jyg
-           zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
-!!           else                                            !jyg
-!!           zdelta = MAX(0.,SIGN(1.,t_glace_min-zx_t))      !jyg
-!!           endif                                           !jyg
-           zx_qs  = r2es * FOEEW(zx_t,zdelta)/pplay(i,k)
-           zx_qs  = MIN(0.5,zx_qs)
-           zcor   = 1./(1.-retv*zx_qs)
-           zx_qs  = zx_qs*zcor
-        ELSE
-!!           IF (zx_t.LT.t_coup) THEN             !jyg
-           IF (zx_t.LT.rtt) THEN                  !jyg
-              zx_qs = qsats(zx_t)/pplay(i,k)
-           ELSE
-              zx_qs = qsatl(zx_t)/pplay(i,k)
-           ENDIF
-        ENDIF
-        zx_rh(i,k) = q_seri(i,k)/zx_qs
-        zqsat(i,k)=zx_qs
-     ENDDO
-  ENDDO
-
-  !IM Calcul temp.potentielle a 2m (tpot) et temp. potentielle 
-  !   equivalente a 2m (tpote) pour diagnostique
-  !
-  DO i = 1, klon
-     tpot(i)=zt2m(i)*(100000./paprs(i,1))**RKAPPA
-     IF (thermcep) THEN
-        IF(zt2m(i).LT.RTT) then
-           Lheat=RLSTT
-        ELSE
-           Lheat=RLVTT
-        ENDIF
-     ELSE
-        IF (zt2m(i).LT.RTT) THEN
-           Lheat=RLSTT
-        ELSE
-           Lheat=RLVTT
-        ENDIF
-     ENDIF
-     tpote(i) = tpot(i)*      &
-          EXP((Lheat *qsat2m(i))/(RCPD*zt2m(i)))
-  ENDDO
-
-  IF (type_trac == 'inca') THEN
+          ENDIF
+       ENDIF
+       !--fin STRAT AEROSOL
+
+
+       !   On prend la somme des fractions nuageuses et des contenus en eau
+
+       if (iflag_cld_th>=5) then
+
+          do k=1,klev
+             ptconvth(:,k)=fm_therm(:,k+1)>0.
+          enddo
+
+          if (iflag_coupl==4) then
+
+             ! Dans le cas iflag_coupl==4, on prend la somme des convertures
+             ! convectives et lsc dans la partie des thermiques
+             ! Le controle par iflag_coupl est peut etre provisoire.
+             do k=1,klev
+                do i=1,klon
+                   if (ptconv(i,k).and.ptconvth(i,k)) then
+                      cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                      cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
+                   else if (ptconv(i,k)) then
+                      cldfra(i,k)=rnebcon(i,k)
+                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                   endif
+                enddo
+             enddo
+
+          else if (iflag_coupl==5) then
+             do k=1,klev
+                do i=1,klon
+                   cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
+                   cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                enddo
+             enddo
+
+          else
+
+             ! Si on est sur un point touche par la convection
+             ! profonde et pas par les thermiques, on prend la
+             ! couverture nuageuse et l'eau nuageuse de la convection
+             ! profonde.
+
+             !IM/FH: 2011/02/23 
+             ! definition des points sur lesquels ls thermiques sont actifs
+
+             do k=1,klev
+                do i=1,klon
+                   if (ptconv(i,k).and. .not. ptconvth(i,k)) then
+                      cldfra(i,k)=rnebcon(i,k)
+                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                   endif
+                enddo
+             enddo
+
+          endif
+
+       else
+
+          ! Ancienne version
+          cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
+          cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
+       endif
+
+    ENDIF
+
+    !     plulsc(:)=0.
+    !     do k=1,klev,-1
+    !        do i=1,klon
+    !              zzz=prfl(:,k)+psfl(:,k)
+    !           if (.not.ptconvth.zzz.gt.0.)
+    !        enddo prfl, psfl,
+    !     enddo
+    !
+    ! 2. NUAGES STARTIFORMES
+    !
+    IF (ok_stratus) THEN
+       CALL diagcld2(paprs,pplay,t_seri,q_seri, diafra,dialiq)
+       DO k = 1, klev
+          DO i = 1, klon
+             IF (diafra(i,k).GT.cldfra(i,k)) THEN
+                cldliq(i,k) = dialiq(i,k)
+                cldfra(i,k) = diafra(i,k)
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDIF
+    !
+    ! Precipitation totale
+    !
+    DO i = 1, klon
+       rain_fall(i) = rain_con(i) + rain_lsc(i)
+       snow_fall(i) = snow_con(i) + snow_lsc(i)
+    ENDDO
+    !IM
+    IF (ip_ebil_phy.ge.2) THEN 
+       ztit="after diagcld"
+       CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
+            , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
+            , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+       call diagphy(cell_area,ztit,ip_ebil_phy &
+            , zero_v, zero_v, zero_v, zero_v, zero_v &
+            , zero_v, zero_v, zero_v, ztsol &
+            , d_h_vcol, d_qt, d_ec &
+            , fs_bound, fq_bound )
+    END IF
+    !
+    ! Calculer l'humidite relative pour diagnostique
+    !
+    DO k = 1, klev
+       DO i = 1, klon
+          zx_t = t_seri(i,k)
+          IF (thermcep) THEN
+             !!           if (iflag_ice_thermo.eq.0) then                 !jyg
+             zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
+             !!           else                                            !jyg
+             !!           zdelta = MAX(0.,SIGN(1.,t_glace_min-zx_t))      !jyg
+             !!           endif                                           !jyg
+             zx_qs  = r2es * FOEEW(zx_t,zdelta)/pplay(i,k)
+             zx_qs  = MIN(0.5,zx_qs)
+             zcor   = 1./(1.-retv*zx_qs)
+             zx_qs  = zx_qs*zcor
+          ELSE
+             !!           IF (zx_t.LT.t_coup) THEN             !jyg
+             IF (zx_t.LT.rtt) THEN                  !jyg
+                zx_qs = qsats(zx_t)/pplay(i,k)
+             ELSE
+                zx_qs = qsatl(zx_t)/pplay(i,k)
+             ENDIF
+          ENDIF
+          zx_rh(i,k) = q_seri(i,k)/zx_qs
+          zqsat(i,k)=zx_qs
+       ENDDO
+    ENDDO
+
+    !IM Calcul temp.potentielle a 2m (tpot) et temp. potentielle 
+    !   equivalente a 2m (tpote) pour diagnostique
+    !
+    DO i = 1, klon
+       tpot(i)=zt2m(i)*(100000./paprs(i,1))**RKAPPA
+       IF (thermcep) THEN
+          IF(zt2m(i).LT.RTT) then
+             Lheat=RLSTT
+          ELSE
+             Lheat=RLVTT
+          ENDIF
+       ELSE
+          IF (zt2m(i).LT.RTT) THEN
+             Lheat=RLSTT
+          ELSE
+             Lheat=RLVTT
+          ENDIF
+       ENDIF
+       tpote(i) = tpot(i)*      &
+            EXP((Lheat *qsat2m(i))/(RCPD*zt2m(i)))
+    ENDDO
+
+    IF (type_trac == 'inca') THEN
 #ifdef INCA
-     CALL VTe(VTphysiq)
-     CALL VTb(VTinca)
-     calday = REAL(days_elapsed + 1) + jH_cur
-
-     call chemtime(itap+itau_phy-1, date0, dtime, itap)
-     IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
-        CALL AEROSOL_METEO_CALC( &
-             calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
-             prfl,psfl,pctsrf,cell_area, &
-             latitude_deg,longitude_deg,u10m,v10m)
-     END IF
-
-     zxsnow_dummy(:) = 0.0
-
-     CALL chemhook_begin (calday, &
-          days_elapsed+1, &
-          jH_cur, &
-          pctsrf(1,1), &
-          latitude_deg, &
-          longitude_deg, &
-          cell_area, &
-          paprs, &
-          pplay, &
-          coefh(1:klon,1:klev,is_ave), &
-          pphi, &
-          t_seri, &
-          u, &
-          v, &
-          wo(:, :, 1), &
-          q_seri, &
-          zxtsol, &
-          zxsnow_dummy, &
-          solsw, &
-          albsol1, &
-          rain_fall, &
-          snow_fall, &
-          itop_con, &
-          ibas_con, &
-          cldfra, &
-          nbp_lon, &
-          nbp_lat-1, &
-          tr_seri, &
-          ftsol, &
-          paprs, &
-          cdragh, &
-          cdragm, &
-          pctsrf, &
-          pdtphys, &
-          itap)
-
-     CALL VTe(VTinca)
-     CALL VTb(VTphysiq)
+       CALL VTe(VTphysiq)
+       CALL VTb(VTinca)
+       calday = REAL(days_elapsed + 1) + jH_cur
+
+       call chemtime(itap+itau_phy-1, date0, dtime, itap)
+       IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
+          CALL AEROSOL_METEO_CALC( &
+               calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
+               prfl,psfl,pctsrf,cell_area, &
+               latitude_deg,longitude_deg,u10m,v10m)
+       END IF
+
+       zxsnow_dummy(:) = 0.0
+
+       CALL chemhook_begin (calday, &
+            days_elapsed+1, &
+            jH_cur, &
+            pctsrf(1,1), &
+            latitude_deg, &
+            longitude_deg, &
+            cell_area, &
+            paprs, &
+            pplay, &
+            coefh(1:klon,1:klev,is_ave), &
+            pphi, &
+            t_seri, &
+            u, &
+            v, &
+            wo(:, :, 1), &
+            q_seri, &
+            zxtsol, &
+            zxsnow_dummy, &
+            solsw, &
+            albsol1, &
+            rain_fall, &
+            snow_fall, &
+            itop_con, &
+            ibas_con, &
+            cldfra, &
+            nbp_lon, &
+            nbp_lat-1, &
+            tr_seri, &
+            ftsol, &
+            paprs, &
+            cdragh, &
+            cdragm, &
+            pctsrf, &
+            pdtphys, &
+            itap)
+
+       CALL VTe(VTinca)
+       CALL VTb(VTphysiq)
 #endif 
-  END IF !type_trac = inca
-  !     
-  ! Calculer les parametres optiques des nuages et quelques
-  ! parametres pour diagnostiques:
-  !
-
-  IF (aerosol_couple.AND.config_inca=='aero') THEN 
-     mass_solu_aero(:,:)    = ccm(:,:,1) 
-     mass_solu_aero_pi(:,:) = ccm(:,:,2) 
-  END IF
-
-  if (ok_newmicro) then
-     IF (iflag_rrtm.NE.0) THEN 
+    END IF !type_trac = inca
+    !     
+    ! Calculer les parametres optiques des nuages et quelques
+    ! parametres pour diagnostiques:
+    !
+
+    IF (aerosol_couple.AND.config_inca=='aero') THEN 
+       mass_solu_aero(:,:)    = ccm(:,:,1) 
+       mass_solu_aero_pi(:,:) = ccm(:,:,2) 
+    END IF
+
+    if (ok_newmicro) then
+       IF (iflag_rrtm.NE.0) THEN 
 #ifdef CPP_RRTM
-        IF (ok_cdnc.AND.NRADLP.NE.3) THEN
-           abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 pour ok_cdnc' 
-           call abort_physic(modname,abort_message,1)
-        endif
+          IF (ok_cdnc.AND.NRADLP.NE.3) THEN
+             abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 ' &
+                  // 'pour ok_cdnc' 
+             call abort_physic(modname,abort_message,1)
+          endif
 #else
 
-        abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-        call abort_physic(modname,abort_message,1)
+          abort_message='You should compile with -rrtm if running with ' &
+               // 'iflag_rrtm=1'
+          call abort_physic(modname,abort_message,1)
 #endif
-     ENDIF
-     CALL newmicro (ok_cdnc, bl95_b0, bl95_b1, &
-          paprs, pplay, t_seri, cldliq, cldfra, &
-          cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
-          flwp, fiwp, flwc, fiwc, &
-          mass_solu_aero, mass_solu_aero_pi, &
-          cldtaupi, re, fl, ref_liq, ref_ice, &
-          ref_liq_pi, ref_ice_pi)
-  else
-     CALL nuage (paprs, pplay, &
-          t_seri, cldliq, cldfra, cldtau, cldemi, &
-          cldh, cldl, cldm, cldt, cldq, &
-          ok_aie, &
-          mass_solu_aero, mass_solu_aero_pi, &
-          bl95_b0, bl95_b1, &
-          cldtaupi, re, fl)
-  endif
-  !
-  !IM betaCRF
-  !
-  cldtaurad   = cldtau
-  cldtaupirad = cldtaupi
-  cldemirad   = cldemi
-  cldfrarad   = cldfra
-
-  !
-  if(lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND. &
-       lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
-     !
-     ! global
-     !
-     DO k=1, klev
-        DO i=1, klon
-           if (pplay(i,k).GE.pfree) THEN
-              beta(i,k) = beta_pbl
-           else
-              beta(i,k) = beta_free
-           endif
-           if (mskocean_beta) THEN
-              beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-           endif
-           cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
-           cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
-           cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
-           cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-        ENDDO
-     ENDDO
-     !
-  else
-     !
-     ! regional
-     !
-     DO k=1, klev
-        DO i=1,klon
-           !
-           if (longitude_deg(i).ge.lon1_beta.AND. &
-               longitude_deg(i).le.lon2_beta.AND. &
-               latitude_deg(i).le.lat1_beta.AND. &
-               latitude_deg(i).ge.lat2_beta) THEN
-              if (pplay(i,k).GE.pfree) THEN
-                 beta(i,k) = beta_pbl
-              else
-                 beta(i,k) = beta_free
-              endif
-              if (mskocean_beta) THEN
-                 beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
-              endif
-              cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
-              cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
-              cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
-              cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
-           endif
-           !
-        ENDDO
-     ENDDO
-     !
-  endif
-  !
-  ! Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
-  !
-  IF (MOD(itaprad,radpas).EQ.0) THEN
-
-!albedo SB >>>  
-  if(ok_chlorophyll)then
-  print*,"-- reading chlorophyll"
-  call readchlorophyll(debut)
-  endif
-  !do i=1,klon
-  !if(chl_con(i)>1.) print*,i,chl_con(i),pctsrf(i,is_ter)
-  !enddo
-!albedo SB <<<
-
-
-     if (mydebug) then
-        call writefield_phy('u_seri',u_seri,nbp_lev)
-        call writefield_phy('v_seri',v_seri,nbp_lev)
-        call writefield_phy('t_seri',t_seri,nbp_lev)
-        call writefield_phy('q_seri',q_seri,nbp_lev)
-     endif
-
-!
-!sonia :   If Iflag_radia >=2, pertubation of some variables input to radiation
-!(DICE)
-!
-      IF (iflag_radia .ge. 2) THEN
-        zsav_tsol (:) = zxtsol(:)
-        call perturb_radlwsw(zxtsol,iflag_radia)
-      ENDIF
-
-     IF (aerosol_couple.AND.config_inca=='aero') THEN 
+       ENDIF
+       CALL newmicro (ok_cdnc, bl95_b0, bl95_b1, &
+            paprs, pplay, t_seri, cldliq, cldfra, &
+            cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
+            flwp, fiwp, flwc, fiwc, &
+            mass_solu_aero, mass_solu_aero_pi, &
+            cldtaupi, re, fl, ref_liq, ref_ice, &
+            ref_liq_pi, ref_ice_pi)
+    else
+       CALL nuage (paprs, pplay, &
+            t_seri, cldliq, cldfra, cldtau, cldemi, &
+            cldh, cldl, cldm, cldt, cldq, &
+            ok_aie, &
+            mass_solu_aero, mass_solu_aero_pi, &
+            bl95_b0, bl95_b1, &
+            cldtaupi, re, fl)
+    endif
+    !
+    !IM betaCRF
+    !
+    cldtaurad   = cldtau
+    cldtaupirad = cldtaupi
+    cldemirad   = cldemi
+    cldfrarad   = cldfra
+
+    !
+    if(lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND. &
+         lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
+       !
+       ! global
+       !
+       DO k=1, klev
+          DO i=1, klon
+             if (pplay(i,k).GE.pfree) THEN
+                beta(i,k) = beta_pbl
+             else
+                beta(i,k) = beta_free
+             endif
+             if (mskocean_beta) THEN
+                beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
+             endif
+             cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
+             cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
+             cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
+             cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
+          ENDDO
+       ENDDO
+       !
+    else
+       !
+       ! regional
+       !
+       DO k=1, klev
+          DO i=1,klon
+             !
+             if (longitude_deg(i).ge.lon1_beta.AND. &
+                  longitude_deg(i).le.lon2_beta.AND. &
+                  latitude_deg(i).le.lat1_beta.AND. &
+                  latitude_deg(i).ge.lat2_beta) THEN
+                if (pplay(i,k).GE.pfree) THEN
+                   beta(i,k) = beta_pbl
+                else
+                   beta(i,k) = beta_free
+                endif
+                if (mskocean_beta) THEN
+                   beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
+                endif
+                cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
+                cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
+                cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
+                cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
+             endif
+             !
+          ENDDO
+       ENDDO
+       !
+    endif
+    !
+    ! Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
+    !
+    IF (MOD(itaprad,radpas).EQ.0) THEN
+
+       !albedo SB >>>  
+       if(ok_chlorophyll)then
+          print*,"-- reading chlorophyll"
+          call readchlorophyll(debut)
+       endif
+       !do i=1,klon
+       !if(chl_con(i)>1.) print*,i,chl_con(i),pctsrf(i,is_ter)
+       !enddo
+       !albedo SB <<<
+
+
+       if (mydebug) then
+          call writefield_phy('u_seri',u_seri,nbp_lev)
+          call writefield_phy('v_seri',v_seri,nbp_lev)
+          call writefield_phy('t_seri',t_seri,nbp_lev)
+          call writefield_phy('q_seri',q_seri,nbp_lev)
+       endif
+
+       !
+       !sonia : If Iflag_radia >=2, pertubation of some variables
+       !input to radiation (DICE)
+       !
+       IF (iflag_radia .ge. 2) THEN
+          zsav_tsol (:) = zxtsol(:)
+          call perturb_radlwsw(zxtsol,iflag_radia)
+       ENDIF
+
+       IF (aerosol_couple.AND.config_inca=='aero') THEN 
 #ifdef INCA
-        CALL radlwsw_inca  &
-             (kdlon,kflev,dist, rmu0, fract, solaire, &
-             paprs, pplay,zxtsol,albsol1, albsol2, t_seri,q_seri, &
-             wo(:, :, 1), &
-             cldfrarad, cldemirad, cldtaurad, &
-             heat,heat0,cool,cool0,albpla, &
-             topsw,toplw,solsw,sollw, &
-             sollwdown, &
-             topsw0,toplw0,solsw0,sollw0, &
-             lwdn0, lwdn, lwup0, lwup,  &
-             swdn0, swdn, swup0, swup, &
-             ok_ade, ok_aie, &
-             tau_aero, piz_aero, cg_aero, &
-             topswad_aero, solswad_aero, &
-             topswad0_aero, solswad0_aero, &
-             topsw_aero, topsw0_aero, &
-             solsw_aero, solsw0_aero, &
-             cldtaupirad, &
-             topswai_aero, solswai_aero)
+          CALL radlwsw_inca  &
+               (kdlon,kflev,dist, rmu0, fract, solaire, &
+               paprs, pplay,zxtsol,albsol1, albsol2, t_seri,q_seri, &
+               wo(:, :, 1), &
+               cldfrarad, cldemirad, cldtaurad, &
+               heat,heat0,cool,cool0,albpla, &
+               topsw,toplw,solsw,sollw, &
+               sollwdown, &
+               topsw0,toplw0,solsw0,sollw0, &
+               lwdn0, lwdn, lwup0, lwup,  &
+               swdn0, swdn, swup0, swup, &
+               ok_ade, ok_aie, &
+               tau_aero, piz_aero, cg_aero, &
+               topswad_aero, solswad_aero, &
+               topswad0_aero, solswad0_aero, &
+               topsw_aero, topsw0_aero, &
+               solsw_aero, solsw0_aero, &
+               cldtaupirad, &
+               topswai_aero, solswai_aero)
 
 #endif
-     ELSE
-        !
-        !IM calcul radiatif pour le cas actuel
-        !
-        RCO2 = RCO2_act
-        RCH4 = RCH4_act
-        RN2O = RN2O_act
-        RCFC11 = RCFC11_act
-        RCFC12 = RCFC12_act
-        !
-        IF (prt_level .GE.10) THEN
-           print *,' ->radlwsw, number 1 '
-        ENDIF
-        !
-        CALL radlwsw &
-             (dist, rmu0, fract,  &
-!albedo SB >>>
-!             paprs, pplay,zxtsol,albsol1, albsol2,  &
-             paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif,  &
-!albedo SB <<<
-             t_seri,q_seri,wo, &
-             cldfrarad, cldemirad, cldtaurad, &
-             ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
-             flag_aerosol_strat, &
-             tau_aero, piz_aero, cg_aero, &
-             tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,&     ! Rajoute par OB pour RRTM
-             tau_aero_lw_rrtm, & 
-             cldtaupirad,new_aod, &
-             zqsat, flwc, fiwc, &
-             ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-             heat,heat0,cool,cool0,albpla, &
-             topsw,toplw,solsw,sollw, &
-             sollwdown, &
-             topsw0,toplw0,solsw0,sollw0, &
-             lwdn0, lwdn, lwup0, lwup,  &
-             swdn0, swdn, swup0, swup, &
-             topswad_aero, solswad_aero, &
-             topswai_aero, solswai_aero, &
-             topswad0_aero, solswad0_aero, &
-             topsw_aero, topsw0_aero, &
-             solsw_aero, solsw0_aero, &
-             topswcf_aero, solswcf_aero, &
-             !-C. Kleinschmitt for LW diagnostics
-             toplwad_aero, sollwad_aero,&
-             toplwai_aero, sollwai_aero, &
-             toplwad0_aero, sollwad0_aero,&
-             !-end
-             ZLWFT0_i, ZFLDN0, ZFLUP0, &
-             ZSWFT0_i, ZFSDN0, ZFSUP0)
-
-        !
-        !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
-        !IM des taux doit etre different du taux actuel
-        !IM Par defaut on a les taux perturbes egaux aux taux actuels
-        !
-        if (ok_4xCO2atm) then
-           if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR. &
-                RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR. &
-                RCFC12_per.NE.RCFC12_act) THEN
-              !
-              RCO2 = RCO2_per
-              RCH4 = RCH4_per
-              RN2O = RN2O_per
-              RCFC11 = RCFC11_per
-              RCFC12 = RCFC12_per
-              !
-              IF (prt_level .GE.10) THEN
-                 print *,' ->radlwsw, number 2 '
-              ENDIF
-              !
-              CALL radlwsw &
-                   (dist, rmu0, fract,  &
-!albedo SB >>>
-!                   paprs, pplay,zxtsol,albsol1, albsol2,  &
-                   paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif, & 
-!albedo SB <<<
-                   t_seri,q_seri,wo, &
-                   cldfra, cldemi, cldtau, &
-                   ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
-                   flag_aerosol_strat, &
-                   tau_aero, piz_aero, cg_aero, &
-                   tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,&     ! Rajoute par OB pour RRTM
-                   tau_aero_lw_rrtm, &
-                   cldtaupi,new_aod, &
-                   zqsat, flwc, fiwc, &
-                   ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-                   heatp,heat0p,coolp,cool0p,albplap, &
-                   topswp,toplwp,solswp,sollwp, &
-                   sollwdownp, &
-                   topsw0p,toplw0p,solsw0p,sollw0p, &
-                   lwdn0p, lwdnp, lwup0p, lwupp,  &
-                   swdn0p, swdnp, swup0p, swupp, &
-                   topswad_aerop, solswad_aerop, &
-                   topswai_aerop, solswai_aerop, &
-                   topswad0_aerop, solswad0_aerop, &
-                   topsw_aerop, topsw0_aerop, &
-                   solsw_aerop, solsw0_aerop, &
-                   topswcf_aerop, solswcf_aerop, &
-                   !-C. Kleinschmitt for LW diagnostics
-                   toplwad_aerop, sollwad_aerop,&
-                   toplwai_aerop, sollwai_aerop, &
-                   toplwad0_aerop, sollwad0_aerop,&
-                   !-end
-                   ZLWFT0_i, ZFLDN0, ZFLUP0, &
-                   ZSWFT0_i, ZFSDN0, ZFSUP0)
-           endif
-        endif
-        !
-     ENDIF ! aerosol_couple
-     itaprad = 0
-!
-!  If Iflag_radia >=2, reset pertubed variables
-!
-      IF (iflag_radia .ge. 2) THEN
-        zxtsol(:) = zsav_tsol (:)
-      ENDIF
-  ENDIF ! MOD(itaprad,radpas)
-  itaprad = itaprad + 1
-
-  IF (iflag_radia.eq.0) THEN
-     IF (prt_level.ge.9) THEN
-        PRINT *,'--------------------------------------------------'
-        PRINT *,'>>>> ATTENTION rayonnement desactive pour ce cas'
-        PRINT *,'>>>>           heat et cool mis a zero '
-        PRINT *,'--------------------------------------------------'
-     END IF
-     heat=0.
-     cool=0.
-     sollw=0.   ! MPL 01032011
-     solsw=0.
-     radsol=0.
-     swup=0.    ! MPL 27102011 pour les fichiers AMMA_profiles et AMMA_scalars
-     swup0=0.
-     lwup=0.
-     lwup0=0.
-     lwdn=0.
-     lwdn0=0.
-  END IF
-
-  !
-  ! Calculer radsol a l'exterieur de radlwsw
-  ! pour prendre en compte le cycle diurne
-  ! recode par Olivier Boucher en sept 2015
-  !
-  radsol=solsw*swradcorr+sollw
-  if (ok_4xCO2atm) then
-    radsolp=solswp*swradcorr+sollwp
-  endif
-
-  !
-  ! Ajouter la tendance des rayonnements (tous les pas)
-  ! avec une correction pour le cycle diurne dans le SW
-  !
-  
-  DO k=1, klev
-    d_t_swr(:,k)=swradcorr(:)*heat(:,k)*dtime/RDAY
-    d_t_sw0(:,k)=swradcorr(:)*heat0(:,k)*dtime/RDAY
-    d_t_lwr(:,k)=-cool(:,k)*dtime/RDAY
-    d_t_lw0(:,k)=-cool0(:,k)*dtime/RDAY
-  ENDDO
-
-  CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy)
-  CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy)
-
-  !
-  if (mydebug) then
-     call writefield_phy('u_seri',u_seri,nbp_lev)
-     call writefield_phy('v_seri',v_seri,nbp_lev)
-     call writefield_phy('t_seri',t_seri,nbp_lev)
-     call writefield_phy('q_seri',q_seri,nbp_lev)
-  endif
-
-  !IM
-  IF (ip_ebil_phy.ge.2) THEN 
-     ztit='after rad'
-     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
-          , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
-          , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(cell_area,ztit,ip_ebil_phy &
-          , topsw, toplw, solsw, sollw, zero_v &
-          , zero_v, zero_v, zero_v, ztsol &
-          , d_h_vcol, d_qt, d_ec &
-          , fs_bound, fq_bound )
-  END IF
-  !
-  !
-  ! Calculer l'hydrologie de la surface
-  !
-  !      CALL hydrol(dtime,pctsrf,rain_fall, snow_fall, zxevap,
-  !     .            agesno, ftsol,fqsurf,fsnow, ruis)
-  !
-
-  !
-  ! Calculer le bilan du sol et la derive de temperature (couplage)
-  !
-  DO i = 1, klon
-     !         bils(i) = radsol(i) - sens(i) - evap(i)*RLVTT
-     ! a la demande de JLD
-     bils(i) = radsol(i) - sens(i) + zxfluxlat(i)
-  ENDDO
-  !
-  !moddeblott(jan95)
-  ! Appeler le programme de parametrisation de l'orographie
-  ! a l'echelle sous-maille:
-  !
-  IF (prt_level .GE.10) THEN
-     print *,' call orography ? ', ok_orodr
-  ENDIF
-  !
-  IF (ok_orodr) THEN
-     !
-     !  selection des points pour lesquels le shema est actif:
-     igwd=0
-     DO i=1,klon
-        itest(i)=0
-        !        IF ((zstd(i).gt.10.0)) THEN
-        IF (((zpic(i)-zmea(i)).GT.100.).AND.(zstd(i).GT.10.0)) THEN
-           itest(i)=1
-           igwd=igwd+1
-           idx(igwd)=i
-        ENDIF
-     ENDDO
-     !        igwdim=MAX(1,igwd)
-     !
-     IF (ok_strato) THEN
-
-        CALL drag_noro_strato(klon,klev,dtime,paprs,pplay, &
-             zmea,zstd, zsig, zgam, zthe,zpic,zval, &
-             igwd,idx,itest, &
-             t_seri, u_seri, v_seri, &
-             zulow, zvlow, zustrdr, zvstrdr, &
-             d_t_oro, d_u_oro, d_v_oro)
-
-     ELSE
-        CALL drag_noro(klon,klev,dtime,paprs,pplay, &
-             zmea,zstd, zsig, zgam, zthe,zpic,zval, &
-             igwd,idx,itest, &
-             t_seri, u_seri, v_seri, &
-             zulow, zvlow, zustrdr, zvstrdr, &
-             d_t_oro, d_u_oro, d_v_oro)
-     ENDIF
-     !
-     !  ajout des tendances
-     !-----------------------------------------------------------------------------------------
-     ! ajout des tendances de la trainee de l'orographie
-     CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro',abortphy)
-     !-----------------------------------------------------------------------------------------
-     !
-  ENDIF ! fin de test sur ok_orodr
-  !
-  if (mydebug) then
-     call writefield_phy('u_seri',u_seri,nbp_lev)
-     call writefield_phy('v_seri',v_seri,nbp_lev)
-     call writefield_phy('t_seri',t_seri,nbp_lev)
-     call writefield_phy('q_seri',q_seri,nbp_lev)
-  endif
-
-  IF (ok_orolf) THEN
-     !
-     !  selection des points pour lesquels le shema est actif:
-     igwd=0
-     DO i=1,klon
-        itest(i)=0
-        IF ((zpic(i)-zmea(i)).GT.100.) THEN
-           itest(i)=1
-           igwd=igwd+1
-           idx(igwd)=i
-        ENDIF
-     ENDDO
-     !        igwdim=MAX(1,igwd)
-     !
-     IF (ok_strato) THEN
-
-        CALL lift_noro_strato(klon,klev,dtime,paprs,pplay, &
-             latitude_deg,zmea,zstd,zpic,zgam,zthe,zpic,zval, &
-             igwd,idx,itest, &
-             t_seri, u_seri, v_seri, &
-             zulow, zvlow, zustrli, zvstrli, &
-             d_t_lif, d_u_lif, d_v_lif               )
-
-     ELSE
-        CALL lift_noro(klon,klev,dtime,paprs,pplay, &
-             latitude_deg,zmea,zstd,zpic, &
-             itest, &
-             t_seri, u_seri, v_seri, &
-             zulow, zvlow, zustrli, zvstrli, &
-             d_t_lif, d_u_lif, d_v_lif)
-     ENDIF
-
-     ! ajout des tendances de la portance de l'orographie
-     CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
-          'lif', abortphy)
-  ENDIF ! fin de test sur ok_orolf
-
-  IF (ok_hines) then
-     !  HINES GWD PARAMETRIZATION
-     east_gwstress=0.
-     west_gwstress=0.
-     du_gwd_hines=0.
-     dv_gwd_hines=0.
-     CALL hines_gwd(klon, klev, dtime, paprs, pplay, latitude_deg, t_seri, u_seri, &
-          v_seri, zustr_gwd_hines, zvstr_gwd_hines, d_t_hin, du_gwd_hines, &
-          dv_gwd_hines)
-     zustr_gwd_hines=0.
-     zvstr_gwd_hines=0.
-     DO k = 1, klev
-        zustr_gwd_hines(:)=zustr_gwd_hines(:)+ du_gwd_hines(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-        zvstr_gwd_hines(:)=zvstr_gwd_hines(:)+ dv_gwd_hines(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-     ENDDO
-
-     d_t_hin(:, :)=0.
-     CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, dqi0, &
-          paprs, 'hin', abortphy)
-  ENDIF
-
-  IF (.not. ok_hines .and. ok_gwd_rando) then
-     CALL acama_GWD_rando(DTIME, pplay, latitude_deg, t_seri, u_seri, v_seri, rot, &
-          zustr_gwd_front, zvstr_gwd_front, du_gwd_front, dv_gwd_front, &
-          east_gwstress, west_gwstress)
-     zustr_gwd_front=0.
-     zvstr_gwd_front=0.
-     DO k = 1, klev
-        zustr_gwd_front(:)=zustr_gwd_front(:)+ du_gwd_front(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-        zvstr_gwd_front(:)=zvstr_gwd_front(:)+ dv_gwd_front(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-     ENDDO
-
-     CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
-          paprs, 'front_gwd_rando', abortphy)
-  ENDIF
-
-  if (ok_gwd_rando) then
-     call FLOTT_GWD_rando(DTIME, pplay, t_seri, u_seri, v_seri, &
-          rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
-          du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
-     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
-          paprs, 'flott_gwd_rando', abortphy)
-     zustr_gwd_rando=0.
-     zvstr_gwd_rando=0.
-     DO k = 1, klev
-        zustr_gwd_rando(:)=zustr_gwd_rando(:)+ du_gwd_rando(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-        zvstr_gwd_rando(:)=zvstr_gwd_rando(:)+ dv_gwd_rando(:, k)/dtime &
-             * (paprs(:, k)-paprs(:, k+1))/rg
-     ENDDO
-  end if
-
-  ! STRESS NECESSAIRES: TOUTE LA PHYSIQUE
-
-  if (mydebug) then
-     call writefield_phy('u_seri',u_seri,nbp_lev)
-     call writefield_phy('v_seri',v_seri,nbp_lev)
-     call writefield_phy('t_seri',t_seri,nbp_lev)
-     call writefield_phy('q_seri',q_seri,nbp_lev)
-  endif
-
-  DO i = 1, klon
-     zustrph(i)=0.
-     zvstrph(i)=0.
-  ENDDO
-  DO k = 1, klev
-     DO i = 1, klon
-        zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/dtime* &
-             (paprs(i,k)-paprs(i,k+1))/rg
-        zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/dtime* &
-             (paprs(i,k)-paprs(i,k+1))/rg
-     ENDDO
-  ENDDO
-  !
-  !IM calcul composantes axiales du moment angulaire et couple des montagnes
-  !
-  IF (is_sequential .and. ok_orodr) THEN 
-     CALL aaam_bud (27,klon,klev,jD_cur-jD_ref,jH_cur, &
-          ra,rg,romega, &
-          latitude_deg,longitude_deg,pphis, &
-          zustrdr,zustrli,zustrph, &
-          zvstrdr,zvstrli,zvstrph, &
-          paprs,u,v, &
-          aam, torsfc)
-  ENDIF
-  !IM cf. FLott END
-  !IM
-  IF (ip_ebil_phy.ge.2) THEN 
-     ztit='after orography'
-     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
-          , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
-          , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(cell_area,ztit,ip_ebil_phy &
-          , zero_v, zero_v, zero_v, zero_v, zero_v &
-          , zero_v, zero_v, zero_v, ztsol &
-          , d_h_vcol, d_qt, d_ec &
-          , fs_bound, fq_bound )
-  END IF
-
-  !DC Calcul de la tendance due au methane
-  IF(ok_qch4) THEN
-     CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
-  ! ajout de la tendance d'humidite due au methane
-     CALL add_phys_tend(du0, dv0, dt0, d_q_ch4*dtime, dql0, dqi0, paprs, &
-          'q_ch4', abortphy)
-  END IF
-  !
-  !
-  !====================================================================
-  ! Interface Simulateur COSP (Calipso, ISCCP, MISR, ..)
-  !====================================================================
-  ! Abderrahmane 24.08.09
-
-  IF (ok_cosp) THEN
-     ! adeclarer 
+       ELSE
+          !
+          !IM calcul radiatif pour le cas actuel
+          !
+          RCO2 = RCO2_act
+          RCH4 = RCH4_act
+          RN2O = RN2O_act
+          RCFC11 = RCFC11_act
+          RCFC12 = RCFC12_act
+          !
+          IF (prt_level .GE.10) THEN
+             print *,' ->radlwsw, number 1 '
+          ENDIF
+          !
+          CALL radlwsw &
+               (dist, rmu0, fract,  &
+                                !albedo SB >>>
+                                !      paprs, pplay,zxtsol,albsol1, albsol2,  &
+               paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif,  &
+                                !albedo SB <<<
+               t_seri,q_seri,wo, &
+               cldfrarad, cldemirad, cldtaurad, &
+               ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
+               flag_aerosol_strat, &
+               tau_aero, piz_aero, cg_aero, &
+               tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, & 
+               ! Rajoute par OB pour RRTM
+               tau_aero_lw_rrtm, & 
+               cldtaupirad,new_aod, &
+               zqsat, flwc, fiwc, &
+               ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
+               heat,heat0,cool,cool0,albpla, &
+               topsw,toplw,solsw,sollw, &
+               sollwdown, &
+               topsw0,toplw0,solsw0,sollw0, &
+               lwdn0, lwdn, lwup0, lwup,  &
+               swdn0, swdn, swup0, swup, &
+               topswad_aero, solswad_aero, &
+               topswai_aero, solswai_aero, &
+               topswad0_aero, solswad0_aero, &
+               topsw_aero, topsw0_aero, &
+               solsw_aero, solsw0_aero, &
+               topswcf_aero, solswcf_aero, &
+                                !-C. Kleinschmitt for LW diagnostics
+               toplwad_aero, sollwad_aero,&
+               toplwai_aero, sollwai_aero, &
+               toplwad0_aero, sollwad0_aero,&
+                                !-end
+               ZLWFT0_i, ZFLDN0, ZFLUP0, &
+               ZSWFT0_i, ZFSDN0, ZFSUP0)
+
+          !
+          !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
+          !IM des taux doit etre different du taux actuel
+          !IM Par defaut on a les taux perturbes egaux aux taux actuels
+          !
+          if (ok_4xCO2atm) then
+             if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR. &
+                  RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR. &
+                  RCFC12_per.NE.RCFC12_act) THEN
+                !
+                RCO2 = RCO2_per
+                RCH4 = RCH4_per
+                RN2O = RN2O_per
+                RCFC11 = RCFC11_per
+                RCFC12 = RCFC12_per
+                !
+                IF (prt_level .GE.10) THEN
+                   print *,' ->radlwsw, number 2 '
+                ENDIF
+                !
+                CALL radlwsw &
+                     (dist, rmu0, fract,  &
+                                !albedo SB >>>
+                                !      paprs, pplay,zxtsol,albsol1, albsol2,  &
+                     paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif, & 
+                                !albedo SB <<<
+                     t_seri,q_seri,wo, &
+                     cldfra, cldemi, cldtau, &
+                     ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
+                     flag_aerosol_strat, &
+                     tau_aero, piz_aero, cg_aero, &
+                     tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, &
+                                ! Rajoute par OB pour RRTM
+                     tau_aero_lw_rrtm, &
+                     cldtaupi,new_aod, &
+                     zqsat, flwc, fiwc, &
+                     ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
+                     heatp,heat0p,coolp,cool0p,albplap, &
+                     topswp,toplwp,solswp,sollwp, &
+                     sollwdownp, &
+                     topsw0p,toplw0p,solsw0p,sollw0p, &
+                     lwdn0p, lwdnp, lwup0p, lwupp,  &
+                     swdn0p, swdnp, swup0p, swupp, &
+                     topswad_aerop, solswad_aerop, &
+                     topswai_aerop, solswai_aerop, &
+                     topswad0_aerop, solswad0_aerop, &
+                     topsw_aerop, topsw0_aerop, &
+                     solsw_aerop, solsw0_aerop, &
+                     topswcf_aerop, solswcf_aerop, &
+                                !-C. Kleinschmitt for LW diagnostics
+                     toplwad_aerop, sollwad_aerop,&
+                     toplwai_aerop, sollwai_aerop, &
+                     toplwad0_aerop, sollwad0_aerop,&
+                                !-end
+                     ZLWFT0_i, ZFLDN0, ZFLUP0, &
+                     ZSWFT0_i, ZFSDN0, ZFSUP0)
+             endif
+          endif
+          !
+       ENDIF ! aerosol_couple
+       itaprad = 0
+       !
+       !  If Iflag_radia >=2, reset pertubed variables
+       !
+       IF (iflag_radia .ge. 2) THEN
+          zxtsol(:) = zsav_tsol (:)
+       ENDIF
+    ENDIF ! MOD(itaprad,radpas)
+    itaprad = itaprad + 1
+
+    IF (iflag_radia.eq.0) THEN
+       IF (prt_level.ge.9) THEN
+          PRINT *,'--------------------------------------------------'
+          PRINT *,'>>>> ATTENTION rayonnement desactive pour ce cas'
+          PRINT *,'>>>>           heat et cool mis a zero '
+          PRINT *,'--------------------------------------------------'
+       END IF
+       heat=0.
+       cool=0.
+       sollw=0.   ! MPL 01032011
+       solsw=0.
+       radsol=0.
+       swup=0.    ! MPL 27102011 pour les fichiers AMMA_profiles et AMMA_scalars
+       swup0=0.
+       lwup=0.
+       lwup0=0.
+       lwdn=0.
+       lwdn0=0.
+    END IF
+
+    !
+    ! Calculer radsol a l'exterieur de radlwsw
+    ! pour prendre en compte le cycle diurne
+    ! recode par Olivier Boucher en sept 2015
+    !
+    radsol=solsw*swradcorr+sollw
+    if (ok_4xCO2atm) then
+       radsolp=solswp*swradcorr+sollwp
+    endif
+
+    !
+    ! Ajouter la tendance des rayonnements (tous les pas)
+    ! avec une correction pour le cycle diurne dans le SW
+    !
+
+    DO k=1, klev
+       d_t_swr(:,k)=swradcorr(:)*heat(:,k)*dtime/RDAY
+       d_t_sw0(:,k)=swradcorr(:)*heat0(:,k)*dtime/RDAY
+       d_t_lwr(:,k)=-cool(:,k)*dtime/RDAY
+       d_t_lw0(:,k)=-cool0(:,k)*dtime/RDAY
+    ENDDO
+
+    CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy)
+    CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy)
+
+    !
+    if (mydebug) then
+       call writefield_phy('u_seri',u_seri,nbp_lev)
+       call writefield_phy('v_seri',v_seri,nbp_lev)
+       call writefield_phy('t_seri',t_seri,nbp_lev)
+       call writefield_phy('q_seri',q_seri,nbp_lev)
+    endif
+
+    !IM
+    IF (ip_ebil_phy.ge.2) THEN 
+       ztit='after rad'
+       CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
+            , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
+            , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+       call diagphy(cell_area,ztit,ip_ebil_phy &
+            , topsw, toplw, solsw, sollw, zero_v &
+            , zero_v, zero_v, zero_v, ztsol &
+            , d_h_vcol, d_qt, d_ec &
+            , fs_bound, fq_bound )
+    END IF
+    !
+    !
+    ! Calculer l'hydrologie de la surface
+    !
+    !      CALL hydrol(dtime,pctsrf,rain_fall, snow_fall, zxevap,
+    !     .            agesno, ftsol,fqsurf,fsnow, ruis)
+    !
+
+    !
+    ! Calculer le bilan du sol et la derive de temperature (couplage)
+    !
+    DO i = 1, klon
+       !         bils(i) = radsol(i) - sens(i) - evap(i)*RLVTT
+       ! a la demande de JLD
+       bils(i) = radsol(i) - sens(i) + zxfluxlat(i)
+    ENDDO
+    !
+    !moddeblott(jan95)
+    ! Appeler le programme de parametrisation de l'orographie
+    ! a l'echelle sous-maille:
+    !
+    IF (prt_level .GE.10) THEN
+       print *,' call orography ? ', ok_orodr
+    ENDIF
+    !
+    IF (ok_orodr) THEN
+       !
+       !  selection des points pour lesquels le shema est actif:
+       igwd=0
+       DO i=1,klon
+          itest(i)=0
+          !        IF ((zstd(i).gt.10.0)) THEN
+          IF (((zpic(i)-zmea(i)).GT.100.).AND.(zstd(i).GT.10.0)) THEN
+             itest(i)=1
+             igwd=igwd+1
+             idx(igwd)=i
+          ENDIF
+       ENDDO
+       !        igwdim=MAX(1,igwd)
+       !
+       IF (ok_strato) THEN
+
+          CALL drag_noro_strato(klon,klev,dtime,paprs,pplay, &
+               zmea,zstd, zsig, zgam, zthe,zpic,zval, &
+               igwd,idx,itest, &
+               t_seri, u_seri, v_seri, &
+               zulow, zvlow, zustrdr, zvstrdr, &
+               d_t_oro, d_u_oro, d_v_oro)
+
+       ELSE
+          CALL drag_noro(klon,klev,dtime,paprs,pplay, &
+               zmea,zstd, zsig, zgam, zthe,zpic,zval, &
+               igwd,idx,itest, &
+               t_seri, u_seri, v_seri, &
+               zulow, zvlow, zustrdr, zvstrdr, &
+               d_t_oro, d_u_oro, d_v_oro)
+       ENDIF
+       !
+       !  ajout des tendances
+       !-----------------------------------------------------------------------
+       ! ajout des tendances de la trainee de l'orographie
+       CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,dqi0,paprs,'oro', &
+            abortphy)
+       !----------------------------------------------------------------------
+       !
+    ENDIF ! fin de test sur ok_orodr
+    !
+    if (mydebug) then
+       call writefield_phy('u_seri',u_seri,nbp_lev)
+       call writefield_phy('v_seri',v_seri,nbp_lev)
+       call writefield_phy('t_seri',t_seri,nbp_lev)
+       call writefield_phy('q_seri',q_seri,nbp_lev)
+    endif
+
+    IF (ok_orolf) THEN
+       !
+       !  selection des points pour lesquels le shema est actif:
+       igwd=0
+       DO i=1,klon
+          itest(i)=0
+          IF ((zpic(i)-zmea(i)).GT.100.) THEN
+             itest(i)=1
+             igwd=igwd+1
+             idx(igwd)=i
+          ENDIF
+       ENDDO
+       !        igwdim=MAX(1,igwd)
+       !
+       IF (ok_strato) THEN
+
+          CALL lift_noro_strato(klon,klev,dtime,paprs,pplay, &
+               latitude_deg,zmea,zstd,zpic,zgam,zthe,zpic,zval, &
+               igwd,idx,itest, &
+               t_seri, u_seri, v_seri, &
+               zulow, zvlow, zustrli, zvstrli, &
+               d_t_lif, d_u_lif, d_v_lif               )
+
+       ELSE
+          CALL lift_noro(klon,klev,dtime,paprs,pplay, &
+               latitude_deg,zmea,zstd,zpic, &
+               itest, &
+               t_seri, u_seri, v_seri, &
+               zulow, zvlow, zustrli, zvstrli, &
+               d_t_lif, d_u_lif, d_v_lif)
+       ENDIF
+
+       ! ajout des tendances de la portance de l'orographie
+       CALL add_phys_tend(d_u_lif, d_v_lif, d_t_lif, dq0, dql0, dqi0, paprs, &
+            'lif', abortphy)
+    ENDIF ! fin de test sur ok_orolf
+
+    IF (ok_hines) then
+       !  HINES GWD PARAMETRIZATION
+       east_gwstress=0.
+       west_gwstress=0.
+       du_gwd_hines=0.
+       dv_gwd_hines=0.
+       CALL hines_gwd(klon, klev, dtime, paprs, pplay, latitude_deg, t_seri, &
+            u_seri, v_seri, zustr_gwd_hines, zvstr_gwd_hines, d_t_hin, &
+            du_gwd_hines, dv_gwd_hines)
+       zustr_gwd_hines=0.
+       zvstr_gwd_hines=0.
+       DO k = 1, klev
+          zustr_gwd_hines(:)=zustr_gwd_hines(:)+ du_gwd_hines(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+          zvstr_gwd_hines(:)=zvstr_gwd_hines(:)+ dv_gwd_hines(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+       ENDDO
+
+       d_t_hin(:, :)=0.
+       CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, &
+            dqi0, paprs, 'hin', abortphy)
+    ENDIF
+
+    IF (.not. ok_hines .and. ok_gwd_rando) then
+       CALL acama_GWD_rando(DTIME, pplay, latitude_deg, t_seri, u_seri, &
+            v_seri, rot, zustr_gwd_front, zvstr_gwd_front, du_gwd_front, &
+            dv_gwd_front, east_gwstress, west_gwstress)
+       zustr_gwd_front=0.
+       zvstr_gwd_front=0.
+       DO k = 1, klev
+          zustr_gwd_front(:)=zustr_gwd_front(:)+ du_gwd_front(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+          zvstr_gwd_front(:)=zvstr_gwd_front(:)+ dv_gwd_front(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+       ENDDO
+
+       CALL add_phys_tend(du_gwd_front, dv_gwd_front, dt0, dq0, dql0, dqi0, &
+            paprs, 'front_gwd_rando', abortphy)
+    ENDIF
+
+    if (ok_gwd_rando) then
+       call FLOTT_GWD_rando(DTIME, pplay, t_seri, u_seri, v_seri, &
+            rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
+            du_gwd_rando, dv_gwd_rando, east_gwstress, west_gwstress)
+       CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, dqi0, &
+            paprs, 'flott_gwd_rando', abortphy)
+       zustr_gwd_rando=0.
+       zvstr_gwd_rando=0.
+       DO k = 1, klev
+          zustr_gwd_rando(:)=zustr_gwd_rando(:)+ du_gwd_rando(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+          zvstr_gwd_rando(:)=zvstr_gwd_rando(:)+ dv_gwd_rando(:, k)/dtime &
+               * (paprs(:, k)-paprs(:, k+1))/rg
+       ENDDO
+    end if
+
+    ! STRESS NECESSAIRES: TOUTE LA PHYSIQUE
+
+    if (mydebug) then
+       call writefield_phy('u_seri',u_seri,nbp_lev)
+       call writefield_phy('v_seri',v_seri,nbp_lev)
+       call writefield_phy('t_seri',t_seri,nbp_lev)
+       call writefield_phy('q_seri',q_seri,nbp_lev)
+    endif
+
+    DO i = 1, klon
+       zustrph(i)=0.
+       zvstrph(i)=0.
+    ENDDO
+    DO k = 1, klev
+       DO i = 1, klon
+          zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/dtime* &
+               (paprs(i,k)-paprs(i,k+1))/rg
+          zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/dtime* &
+               (paprs(i,k)-paprs(i,k+1))/rg
+       ENDDO
+    ENDDO
+    !
+    !IM calcul composantes axiales du moment angulaire et couple des montagnes
+    !
+    IF (is_sequential .and. ok_orodr) THEN 
+       CALL aaam_bud (27,klon,klev,jD_cur-jD_ref,jH_cur, &
+            ra,rg,romega, &
+            latitude_deg,longitude_deg,pphis, &
+            zustrdr,zustrli,zustrph, &
+            zvstrdr,zvstrli,zvstrph, &
+            paprs,u,v, &
+            aam, torsfc)
+    ENDIF
+    !IM cf. FLott END
+    !IM
+    IF (ip_ebil_phy.ge.2) THEN 
+       ztit='after orography'
+       CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
+            , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
+            , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+       call diagphy(cell_area,ztit,ip_ebil_phy &
+            , zero_v, zero_v, zero_v, zero_v, zero_v &
+            , zero_v, zero_v, zero_v, ztsol &
+            , d_h_vcol, d_qt, d_ec &
+            , fs_bound, fq_bound )
+    END IF
+
+    !DC Calcul de la tendance due au methane
+    IF(ok_qch4) THEN
+       CALL METHOX(1,klon,klon,klev,q_seri,d_q_ch4,pplay)
+       ! ajout de la tendance d'humidite due au methane
+       CALL add_phys_tend(du0, dv0, dt0, d_q_ch4*dtime, dql0, dqi0, paprs, &
+            'q_ch4', abortphy)
+    END IF
+    !
+    !
+    !====================================================================
+    ! Interface Simulateur COSP (Calipso, ISCCP, MISR, ..)
+    !====================================================================
+    ! Abderrahmane 24.08.09
+
+    IF (ok_cosp) THEN
+       ! adeclarer 
 #ifdef CPP_COSP
-     IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/dtime)).EQ.0) THEN
-
-      IF (prt_level .GE.10) THEN
-        print*,'freq_cosp',freq_cosp
-      ENDIF
-        mr_ozone=wo(:, :, 1) * dobson_u * 1e3 / zmasse
-        !       print*,'Dans physiq.F avant appel cosp ref_liq,ref_ice=',
-        !     s        ref_liq,ref_ice
-        call phys_cosp(itap,dtime,freq_cosp, &
-             ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
-             ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, &
-             klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
-             JrNt,ref_liq,ref_ice, &
-             pctsrf(:,is_ter)+pctsrf(:,is_lic), &
-             zu10m,zv10m,pphis, &
-             zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
-             qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
-             prfl(:,1:klev),psfl(:,1:klev), &
-             pmflxr(:,1:klev),pmflxs(:,1:klev), &
-             mr_ozone,cldtau, cldemi)
-
-        !     L          calipso2D,calipso3D,cfadlidar,parasolrefl,atb,betamol,
-        !     L          cfaddbze,clcalipso2,dbze,cltlidarradar,
-        !     M          clMISR,
-        !     R          clisccp2,boxtauisccp,boxptopisccp,tclisccp,ctpisccp,
-        !     I          tauisccp,albisccp,meantbisccp,meantbclrisccp)
-
-     ENDIF
+       IF (itap.eq.1.or.MOD(itap,NINT(freq_cosp/dtime)).EQ.0) THEN
+
+          IF (prt_level .GE.10) THEN
+             print*,'freq_cosp',freq_cosp
+          ENDIF
+          mr_ozone=wo(:, :, 1) * dobson_u * 1e3 / zmasse
+          !       print*,'Dans physiq.F avant appel cosp ref_liq,ref_ice=',
+          !     s        ref_liq,ref_ice
+          call phys_cosp(itap,dtime,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+
+          !     L         calipso2D,calipso3D,cfadlidar,parasolrefl,atb,betamol,
+          !     L          cfaddbze,clcalipso2,dbze,cltlidarradar,
+          !     M          clMISR,
+          !     R          clisccp2,boxtauisccp,boxptopisccp,tclisccp,ctpisccp,
+          !     I          tauisccp,albisccp,meantbisccp,meantbclrisccp)
+
+       ENDIF
 
 #endif
-  ENDIF  !ok_cosp
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-  !AA
-  !AA Installation de l'interface online-offline pour traceurs
-  !AA
-  !====================================================================
-  !   Calcul  des tendances traceurs
-  !====================================================================
-  !
-
-  IF (type_trac=='repr') THEN
-     sh_in(:,:) = q_seri(:,:)
-  ELSE
-     sh_in(:,:) = qx(:,:,ivap)
-  END IF
-
-  call phytrac ( &
-       itap,     days_elapsed+1,    jH_cur,   debut, &
-       lafin,    dtime,     u, v,     t, &
-       paprs,    pplay,     pmfu,     pmfd, &
-       pen_u,    pde_u,     pen_d,    pde_d, &
-       cdragh,   coefh(1:klon,1:klev,is_ave),   fm_therm, entr_therm, &
-       u1,       v1,        ftsol,    pctsrf, &
-       zustar,   zu10m,     zv10m, &
-       wstar(:,is_ave),    ale_bl,         ale_wake, &
-       latitude_deg, longitude_deg, &
-       frac_impa,frac_nucl, beta_prec_fisrt,beta_prec, &
-       presnivs, pphis,     pphi,     albsol1, &
-       sh_in,    rhcl,      cldfra,   rneb, &
-       diafra,   cldliq,    itop_con, ibas_con, &
-       pmflxr,   pmflxs,    prfl,     psfl, &
-       da,       phi,       mp,       upwd, &
-       phi2,     d1a,       dam,      sij, wght_cvfd, &        !<<RomP+RL
-       wdtrainA, wdtrainM,  sigd,     clw,elij, &   !<<RomP
-       ev,       ep,        epmlmMm,  eplaMm, &     !<<RomP
-       dnwd,     aerosol_couple,      flxmass_w, &
-       tau_aero, piz_aero,  cg_aero,  ccm, &
-       rfname, &
-       d_tr_dyn, &                                 !<<RomP
-       tr_seri)
-
-  IF (offline) THEN
-
-     IF (prt_level.ge.9) &
-          print*,'Attention on met a 0 les thermiques pour phystoke'
-     call phystokenc ( &
-          nlon,klev,pdtphys,longitude_deg,latitude_deg, &
-          t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
-          fm_therm,entr_therm, &
-          cdragh,coefh(1:klon,1:klev,is_ave),u1,v1,ftsol,pctsrf, &
-          frac_impa, frac_nucl, &
-          pphis,cell_area,dtime,itap, &
-          qx(:,:,ivap),da,phi,mp,upwd,dnwd)
-
-
-  ENDIF
-
-  !
-  ! Calculer le transport de l'eau et de l'energie (diagnostique)
-  !
-  CALL transp (paprs,zxtsol, &
-       t_seri, q_seri, u_seri, v_seri, zphi, &
-       ve, vq, ue, uq)
-  !
-  !IM global posePB BEG
-  IF(1.EQ.0) THEN
-     !
-     CALL transp_lay (paprs,zxtsol, &
-          t_seri, q_seri, u_seri, v_seri, zphi, &
-          ve_lay, vq_lay, ue_lay, uq_lay)
-     !
-  ENDIF !(1.EQ.0) THEN
-  !IM global posePB END
-  ! Accumuler les variables a stocker dans les fichiers histoire:
-  !
-
-  !================================================================
-  ! Conversion of kinetic and potential energy into heat, for
-  ! parameterisation of subgrid-scale motions
-  !================================================================
-
-  d_t_ec(:,:)=0.
-  forall (k=1: nbp_lev) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
-  CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx(:,:,ivap), &
-       u_seri,v_seri,t_seri,q_seri,pbl_tke(:,:,is_ave)-tke0(:,:), &
-       zmasse,exner,d_t_ec)
-  t_seri(:,:)=t_seri(:,:)+d_t_ec(:,:)
-
-  !IM
-  IF (ip_ebil_phy.ge.1) THEN 
-     ztit='after physic'
-     CALL diagetpq(cell_area,ztit,ip_ebil_phy,1,1,dtime &
-          , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
-          , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     !     Comme les tendances de la physique sont ajoute dans la dynamique,
-     !     on devrait avoir que la variation d'entalpie par la dynamique
-     !     est egale a la variation de la physique au pas de temps precedent.
-     !     Donc la somme de ces 2 variations devrait etre nulle.
-
-     call diagphy(cell_area,ztit,ip_ebil_phy &
-          , topsw, toplw, solsw, sollw, sens &
-          , evap, rain_fall, snow_fall, ztsol &
-          , d_h_vcol, d_qt, d_ec &
-          , fs_bound, fq_bound )
-     !
-     d_h_vcol_phy=d_h_vcol
-     !
-  END IF
-  !
-  !=======================================================================
-  !   SORTIES
-  !=======================================================================
-  !
-  !IM initialisation + calculs divers diag AMIP2
-  !
-  include "calcul_divers.h"
-  !
-  !IM Interpolation sur les niveaux de pression du NMC
-  !   -------------------------------------------------
+    ENDIF  !ok_cosp
+    ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !AA
+    !AA Installation de l'interface online-offline pour traceurs
+    !AA
+    !====================================================================
+    !   Calcul  des tendances traceurs
+    !====================================================================
+    !
+
+    IF (type_trac=='repr') THEN
+       sh_in(:,:) = q_seri(:,:)
+    ELSE
+       sh_in(:,:) = qx(:,:,ivap)
+    END IF
+
+    call phytrac ( &
+         itap,     days_elapsed+1,    jH_cur,   debut, &
+         lafin,    dtime,     u, v,     t, &
+         paprs,    pplay,     pmfu,     pmfd, &
+         pen_u,    pde_u,     pen_d,    pde_d, &
+         cdragh,   coefh(1:klon,1:klev,is_ave),   fm_therm, entr_therm, &
+         u1,       v1,        ftsol,    pctsrf, &
+         zustar,   zu10m,     zv10m, &
+         wstar(:,is_ave),    ale_bl,         ale_wake, &
+         latitude_deg, longitude_deg, &
+         frac_impa,frac_nucl, beta_prec_fisrt,beta_prec, &
+         presnivs, pphis,     pphi,     albsol1, &
+         sh_in,    rhcl,      cldfra,   rneb, &
+         diafra,   cldliq,    itop_con, ibas_con, &
+         pmflxr,   pmflxs,    prfl,     psfl, &
+         da,       phi,       mp,       upwd, &
+         phi2,     d1a,       dam,      sij, wght_cvfd, &        !<<RomP+RL
+         wdtrainA, wdtrainM,  sigd,     clw,elij, &   !<<RomP
+         ev,       ep,        epmlmMm,  eplaMm, &     !<<RomP
+         dnwd,     aerosol_couple,      flxmass_w, &
+         tau_aero, piz_aero,  cg_aero,  ccm, &
+         rfname, &
+         d_tr_dyn, &                                 !<<RomP
+         tr_seri)
+
+    IF (offline) THEN
+
+       IF (prt_level.ge.9) &
+            print*,'Attention on met a 0 les thermiques pour phystoke'
+       call phystokenc ( &
+            nlon,klev,pdtphys,longitude_deg,latitude_deg, &
+            t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
+            fm_therm,entr_therm, &
+            cdragh,coefh(1:klon,1:klev,is_ave),u1,v1,ftsol,pctsrf, &
+            frac_impa, frac_nucl, &
+            pphis,cell_area,dtime,itap, &
+            qx(:,:,ivap),da,phi,mp,upwd,dnwd)
+
+
+    ENDIF
+
+    !
+    ! Calculer le transport de l'eau et de l'energie (diagnostique)
+    !
+    CALL transp (paprs,zxtsol, &
+         t_seri, q_seri, u_seri, v_seri, zphi, &
+         ve, vq, ue, uq)
+    !
+    !IM global posePB BEG
+    IF(1.EQ.0) THEN
+       !
+       CALL transp_lay (paprs,zxtsol, &
+            t_seri, q_seri, u_seri, v_seri, zphi, &
+            ve_lay, vq_lay, ue_lay, uq_lay)
+       !
+    ENDIF !(1.EQ.0) THEN
+    !IM global posePB END
+    ! Accumuler les variables a stocker dans les fichiers histoire:
+    !
+
+    !================================================================
+    ! Conversion of kinetic and potential energy into heat, for
+    ! parameterisation of subgrid-scale motions
+    !================================================================
+
+    d_t_ec(:,:)=0.
+    forall (k=1: nbp_lev) exner(:, k) = (pplay(:, k)/paprs(:,1))**RKAPPA
+    CALL ener_conserv(klon,klev,pdtphys,u,v,t,qx(:,:,ivap), &
+         u_seri,v_seri,t_seri,q_seri,pbl_tke(:,:,is_ave)-tke0(:,:), &
+         zmasse,exner,d_t_ec)
+    t_seri(:,:)=t_seri(:,:)+d_t_ec(:,:)
+
+    !IM
+    IF (ip_ebil_phy.ge.1) THEN 
+       ztit='after physic'
+       CALL diagetpq(cell_area,ztit,ip_ebil_phy,1,1,dtime &
+            , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
+            , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+       !     Comme les tendances de la physique sont ajoute dans la dynamique,
+       !     on devrait avoir que la variation d'entalpie par la dynamique
+       !     est egale a la variation de la physique au pas de temps precedent.
+       !     Donc la somme de ces 2 variations devrait etre nulle.
+
+       call diagphy(cell_area,ztit,ip_ebil_phy &
+            , topsw, toplw, solsw, sollw, sens &
+            , evap, rain_fall, snow_fall, ztsol &
+            , d_h_vcol, d_qt, d_ec &
+            , fs_bound, fq_bound )
+       !
+       d_h_vcol_phy=d_h_vcol
+       !
+    END IF
+    !
+    !=======================================================================
+    !   SORTIES
+    !=======================================================================
+    !
+    !IM initialisation + calculs divers diag AMIP2
+    !
+    include "calcul_divers.h"
+    !
+    !IM Interpolation sur les niveaux de pression du NMC
+    !   -------------------------------------------------
 #ifdef CPP_XIOS
-          !$OMP MASTER
-          !On recupere la valeur de la missing value donnee dans le xml
-          CALL xios_get_field_attr("t850",default_value=missing_val_omp)
-!         PRINT *,"ARNAUD value missing ",missing_val_omp
-          !$OMP END MASTER
-          !$OMP BARRIER
-          missing_val=missing_val_omp
+    !$OMP MASTER
+    !On recupere la valeur de la missing value donnee dans le xml
+    CALL xios_get_field_attr("t850",default_value=missing_val_omp)
+    !         PRINT *,"ARNAUD value missing ",missing_val_omp
+    !$OMP END MASTER
+    !$OMP BARRIER
+    missing_val=missing_val_omp
 #endif
 #ifndef CPP_XIOS
-          missing_val=missing_val_nf90
+    missing_val=missing_val_nf90
 #endif
-  !
-  include "calcul_STDlev.h"
-  !
-  ! slp sea level pressure derived from Arpege-IFS : CALL ctstar + CALL pppmer
-  CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
-  !
-  !cc prw = eau precipitable
-  DO i = 1, klon
-     prw(i) = 0.
-     DO k = 1, klev
-        prw(i) = prw(i) + &
-             q_seri(i,k)*(paprs(i,k)-paprs(i,k+1))/RG
-     ENDDO
-  ENDDO
-  !
-  IF (type_trac == 'inca') THEN
+    !
+    include "calcul_STDlev.h"
+    !
+    ! slp sea level pressure derived from Arpege-IFS : CALL ctstar + CALL pppmer
+    CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
+    !
+    !cc prw = eau precipitable
+    DO i = 1, klon
+       prw(i) = 0.
+       DO k = 1, klev
+          prw(i) = prw(i) + &
+               q_seri(i,k)*(paprs(i,k)-paprs(i,k+1))/RG
+       ENDDO
+    ENDDO
+    !
+    IF (type_trac == 'inca') THEN
 #ifdef INCA
-     CALL VTe(VTphysiq)
-     CALL VTb(VTinca)
-
-     CALL chemhook_end ( &
-          dtime, &
-          pplay, &
-          t_seri, &
-          tr_seri, &
-          nbtr, &
-          paprs, &
-          q_seri, &
-          cell_area, &
-          pphi, &
-          pphis, &
-          zx_rh)
-
-     CALL VTe(VTinca)
-     CALL VTb(VTphysiq)
+       CALL VTe(VTphysiq)
+       CALL VTb(VTinca)
+
+       CALL chemhook_end ( &
+            dtime, &
+            pplay, &
+            t_seri, &
+            tr_seri, &
+            nbtr, &
+            paprs, &
+            q_seri, &
+            cell_area, &
+            pphi, &
+            pphis, &
+            zx_rh)
+
+       CALL VTe(VTinca)
+       CALL VTb(VTphysiq)
 #endif
-  END IF
-
-
-  !
-  ! Convertir les incrementations en tendances
-  !
-  IF (prt_level .GE.10) THEN
-     print *,'Convertir les incrementations en tendances '
-  ENDIF
-  !
-  if (mydebug) then
-     call writefield_phy('u_seri',u_seri,nbp_lev)
-     call writefield_phy('v_seri',v_seri,nbp_lev)
-     call writefield_phy('t_seri',t_seri,nbp_lev)
-     call writefield_phy('q_seri',q_seri,nbp_lev)
-  endif
-
-  DO k = 1, klev
-     DO i = 1, klon
-        d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / dtime
-        d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / dtime
-        d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / dtime
-        d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / dtime
-        d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / dtime
-!CR: on ajoute le contenu en glace
-        if (nqo.eq.3) then
-        d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / dtime
-        endif
-     ENDDO
-  ENDDO
-  !
-!CR: nb de traceurs eau: nqo
-!  IF (nqtot.GE.3) THEN
-   IF (nqtot.GE.(nqo+1)) THEN
-!     DO iq = 3, nqtot
-     DO iq = nqo+1, nqtot
-        DO  k = 1, klev
-           DO  i = 1, klon
-!              d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / dtime
-               d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / dtime
-           ENDDO
-        ENDDO
-     ENDDO
-  ENDIF
-  !
-  !IM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
-  !IM global posePB      include "write_bilKP_ins.h"
-  !IM global posePB      include "write_bilKP_ave.h"
-  !
-
-  ! Sauvegarder les valeurs de t et q a la fin de la physique:
-  !
-  DO k = 1, klev
-     DO i = 1, klon
-        u_ancien(i,k) = u_seri(i,k)
-        v_ancien(i,k) = v_seri(i,k)
-        t_ancien(i,k) = t_seri(i,k)
-        q_ancien(i,k) = q_seri(i,k)
-     ENDDO
-  ENDDO
-
-!!! RomP >>>
-!CR: nb de traceurs eau: nqo
-!  IF (nqtot.GE.3) THEN
-   IF (nqtot.GE.(nqo+1)) THEN
-!     DO iq = 3, nqtot
-     DO iq = nqo+1, nqtot
-        DO k = 1, klev
-           DO i = 1, klon
-!              tr_ancien(i,k,iq-2) = tr_seri(i,k,iq-2)
-              tr_ancien(i,k,iq-nqo) = tr_seri(i,k,iq-nqo)
-           ENDDO
-        ENDDO
-     ENDDO
-  ENDIF
-!!! RomP <<<
-  !==========================================================================
-  ! Sorties des tendances pour un point particulier
-  ! a utiliser en 1D, avec igout=1 ou en 3D sur un point particulier
-  ! pour le debug
-  ! La valeur de igout est attribuee plus haut dans le programme
-  !==========================================================================
-
-  if (prt_level.ge.1) then
-     write(lunout,*) 'FIN DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
-     write(lunout,*) &
-          'nlon,klev,nqtot,debut,lafin,jD_cur, jH_cur, pdtphys pct tlos'
-     write(lunout,*) &
-          nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur ,pdtphys, &
-          pctsrf(igout,is_ter), pctsrf(igout,is_lic),pctsrf(igout,is_oce), &
-          pctsrf(igout,is_sic)
-     write(lunout,*) 'd_t_dyn,d_t_con,d_t_lsc,d_t_ajsb,d_t_ajs,d_t_eva'
-     do k=1,klev
-        write(lunout,*) d_t_dyn(igout,k),d_t_con(igout,k), &
-             d_t_lsc(igout,k),d_t_ajsb(igout,k),d_t_ajs(igout,k), &
-             d_t_eva(igout,k)
-     enddo
-     write(lunout,*) 'cool,heat'
-     do k=1,klev
-        write(lunout,*) cool(igout,k),heat(igout,k)
-     enddo
-
-!jyg<     (En attendant de statuer sur le sort de d_t_oli)
-!jyg!     write(lunout,*) 'd_t_oli,d_t_vdf,d_t_oro,d_t_lif,d_t_ec'
-!jyg!     do k=1,klev
-!jyg!        write(lunout,*) d_t_oli(igout,k),d_t_vdf(igout,k), &
-!jyg!             d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
-!jyg!     enddo
-     write(lunout,*) 'd_t_vdf,d_t_oro,d_t_lif,d_t_ec'
-     do k=1,klev
-        write(lunout,*) d_t_vdf(igout,k), &
-             d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
-     enddo
-!>jyg
-
-     write(lunout,*) 'd_ps ',d_ps(igout)
-     write(lunout,*) 'd_u, d_v, d_t, d_qx1, d_qx2 '
-     do k=1,klev
-        write(lunout,*) d_u(igout,k),d_v(igout,k),d_t(igout,k), &
-             d_qx(igout,k,1),d_qx(igout,k,2)
-     enddo
-  endif
-
-  !==========================================================================
-
-  !============================================================
-  !   Calcul de la temperature potentielle
-  !============================================================
-  DO k = 1, klev
-     DO i = 1, klon
-        !JYG/IM theta en debut du pas de temps
-        !JYG/IM       theta(i,k)=t(i,k)*(100000./pplay(i,k))**(RD/RCPD)
-        !JYG/IM theta en fin de pas de temps de physique
-        theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
-        ! thetal: 2 lignes suivantes a decommenter si vous avez les fichiers     MPL 20130625
-        ! fth_fonctions.F90 et parkind1.F90
-        ! sinon thetal=theta
-        !       thetal(i,k)=fth_thetal(pplay(i,k),t_seri(i,k),q_seri(i,k),
-        !    :         ql_seri(i,k))
-        thetal(i,k)=theta(i,k)
-     ENDDO
-  ENDDO
-  !
-
-  ! 22.03.04 BEG
-  !=============================================================
-  !   Ecriture des sorties
-  !=============================================================
+    END IF
+
+
+    !
+    ! Convertir les incrementations en tendances
+    !
+    IF (prt_level .GE.10) THEN
+       print *,'Convertir les incrementations en tendances '
+    ENDIF
+    !
+    if (mydebug) then
+       call writefield_phy('u_seri',u_seri,nbp_lev)
+       call writefield_phy('v_seri',v_seri,nbp_lev)
+       call writefield_phy('t_seri',t_seri,nbp_lev)
+       call writefield_phy('q_seri',q_seri,nbp_lev)
+    endif
+
+    DO k = 1, klev
+       DO i = 1, klon
+          d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / dtime
+          d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / dtime
+          d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / dtime
+          d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / dtime
+          d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / dtime
+          !CR: on ajoute le contenu en glace
+          if (nqo.eq.3) then
+             d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / dtime
+          endif
+       ENDDO
+    ENDDO
+    !
+    !CR: nb de traceurs eau: nqo
+    !  IF (nqtot.GE.3) THEN
+    IF (nqtot.GE.(nqo+1)) THEN
+       !     DO iq = 3, nqtot
+       DO iq = nqo+1, nqtot
+          DO  k = 1, klev
+             DO  i = 1, klon
+                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / dtime
+                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / dtime
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+    !
+    !IM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
+    !IM global posePB      include "write_bilKP_ins.h"
+    !IM global posePB      include "write_bilKP_ave.h"
+    !
+
+    ! Sauvegarder les valeurs de t et q a la fin de la physique:
+    !
+    DO k = 1, klev
+       DO i = 1, klon
+          u_ancien(i,k) = u_seri(i,k)
+          v_ancien(i,k) = v_seri(i,k)
+          t_ancien(i,k) = t_seri(i,k)
+          q_ancien(i,k) = q_seri(i,k)
+       ENDDO
+    ENDDO
+
+    ! !! RomP >>>
+    !CR: nb de traceurs eau: nqo
+    !  IF (nqtot.GE.3) THEN
+    IF (nqtot.GE.(nqo+1)) THEN
+       !     DO iq = 3, nqtot
+       DO iq = nqo+1, nqtot
+          DO k = 1, klev
+             DO i = 1, klon
+                !              tr_ancien(i,k,iq-2) = tr_seri(i,k,iq-2)
+                tr_ancien(i,k,iq-nqo) = tr_seri(i,k,iq-nqo)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+    ! !! RomP <<<
+    !==========================================================================
+    ! Sorties des tendances pour un point particulier
+    ! a utiliser en 1D, avec igout=1 ou en 3D sur un point particulier
+    ! pour le debug
+    ! La valeur de igout est attribuee plus haut dans le programme
+    !==========================================================================
+
+    if (prt_level.ge.1) then
+       write(lunout,*) 'FIN DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
+       write(lunout,*) &
+            'nlon,klev,nqtot,debut,lafin,jD_cur, jH_cur, pdtphys pct tlos'
+       write(lunout,*) &
+            nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur ,pdtphys, &
+            pctsrf(igout,is_ter), pctsrf(igout,is_lic),pctsrf(igout,is_oce), &
+            pctsrf(igout,is_sic)
+       write(lunout,*) 'd_t_dyn,d_t_con,d_t_lsc,d_t_ajsb,d_t_ajs,d_t_eva'
+       do k=1,klev
+          write(lunout,*) d_t_dyn(igout,k),d_t_con(igout,k), &
+               d_t_lsc(igout,k),d_t_ajsb(igout,k),d_t_ajs(igout,k), &
+               d_t_eva(igout,k)
+       enddo
+       write(lunout,*) 'cool,heat'
+       do k=1,klev
+          write(lunout,*) cool(igout,k),heat(igout,k)
+       enddo
+
+       !jyg<     (En attendant de statuer sur le sort de d_t_oli)
+       !jyg!     write(lunout,*) 'd_t_oli,d_t_vdf,d_t_oro,d_t_lif,d_t_ec'
+       !jyg!     do k=1,klev
+       !jyg!        write(lunout,*) d_t_oli(igout,k),d_t_vdf(igout,k), &
+       !jyg!             d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
+       !jyg!     enddo
+       write(lunout,*) 'd_t_vdf,d_t_oro,d_t_lif,d_t_ec'
+       do k=1,klev
+          write(lunout,*) d_t_vdf(igout,k), &
+               d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
+       enddo
+       !>jyg
+
+       write(lunout,*) 'd_ps ',d_ps(igout)
+       write(lunout,*) 'd_u, d_v, d_t, d_qx1, d_qx2 '
+       do k=1,klev
+          write(lunout,*) d_u(igout,k),d_v(igout,k),d_t(igout,k), &
+               d_qx(igout,k,1),d_qx(igout,k,2)
+       enddo
+    endif
+
+    !==========================================================================
+
+    !============================================================
+    !   Calcul de la temperature potentielle
+    !============================================================
+    DO k = 1, klev
+       DO i = 1, klon
+          !JYG/IM theta en debut du pas de temps
+          !JYG/IM       theta(i,k)=t(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+          !JYG/IM theta en fin de pas de temps de physique
+          theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
+          ! thetal: 2 lignes suivantes a decommenter si vous avez les fichiers
+          !     MPL 20130625
+          ! fth_fonctions.F90 et parkind1.F90
+          ! sinon thetal=theta
+          !       thetal(i,k)=fth_thetal(pplay(i,k),t_seri(i,k),q_seri(i,k),
+          !    :         ql_seri(i,k))
+          thetal(i,k)=theta(i,k)
+       ENDDO
+    ENDDO
+    !
+
+    ! 22.03.04 BEG
+    !=============================================================
+    !   Ecriture des sorties
+    !=============================================================
 #ifdef CPP_IOIPSL
 
-  ! Recupere des varibles calcule dans differents modules
-  ! pour ecriture dans histxxx.nc 
-
-  ! Get some variables from module fonte_neige_mod
-  CALL fonte_neige_get_vars(pctsrf,  &
-       zxfqcalving, zxfqfonte, zxffonte)
-
-
-
-
-  !=============================================================
-  ! Separation entre thermiques et non thermiques dans les sorties
-  ! de fisrtilp
-  !=============================================================
-
-  if (iflag_thermals>=1) then
-     d_t_lscth=0.
-     d_t_lscst=0.
-     d_q_lscth=0.
-     d_q_lscst=0.
-     do k=1,klev
-        do i=1,klon
-           if (ptconvth(i,k)) then
-              d_t_lscth(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
-              d_q_lscth(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
-           else
-              d_t_lscst(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
-              d_q_lscst(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
-           endif
-        enddo
-     enddo
-
-     do i=1,klon
-        plul_st(i)=prfl(i,lmax_th(i)+1)+psfl(i,lmax_th(i)+1)
-        plul_th(i)=prfl(i,1)+psfl(i,1)
-     enddo
-  endif
-
-
-  !On effectue les sorties:
-
-  CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
-       pplay, lmax_th, aerosol_couple,                 &
-       ok_ade, ok_aie, ivap, new_aod, ok_sync,         &
-       ptconv, read_climoz, clevSTD,                   &
-       ptconvth, d_t, qx, d_qx, zmasse,                &
-       flag_aerosol, flag_aerosol_strat, ok_cdnc)
-
-
-
-  include "write_histday_seri.h"
-
-  include "write_paramLMDZ_phy.h"
+    ! Recupere des varibles calcule dans differents modules
+    ! pour ecriture dans histxxx.nc 
+
+    ! Get some variables from module fonte_neige_mod
+    CALL fonte_neige_get_vars(pctsrf,  &
+         zxfqcalving, zxfqfonte, zxffonte)
+
+
+
+
+    !=============================================================
+    ! Separation entre thermiques et non thermiques dans les sorties
+    ! de fisrtilp
+    !=============================================================
+
+    if (iflag_thermals>=1) then
+       d_t_lscth=0.
+       d_t_lscst=0.
+       d_q_lscth=0.
+       d_q_lscst=0.
+       do k=1,klev
+          do i=1,klon
+             if (ptconvth(i,k)) then
+                d_t_lscth(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
+                d_q_lscth(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
+             else
+                d_t_lscst(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
+                d_q_lscst(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
+             endif
+          enddo
+       enddo
+
+       do i=1,klon
+          plul_st(i)=prfl(i,lmax_th(i)+1)+psfl(i,lmax_th(i)+1)
+          plul_th(i)=prfl(i,1)+psfl(i,1)
+       enddo
+    endif
+
+
+    !On effectue les sorties:
+
+    CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
+         pplay, lmax_th, aerosol_couple,                 &
+         ok_ade, ok_aie, ivap, new_aod, ok_sync,         &
+         ptconv, read_climoz, clevSTD,                   &
+         ptconvth, d_t, qx, d_qx, zmasse,                &
+         flag_aerosol, flag_aerosol_strat, ok_cdnc)
+
+
+
+    include "write_histday_seri.h"
+
+    include "write_paramLMDZ_phy.h"
 
 #endif
 
 
-!====================================================================
-! Arret du modele apres hgardfou en cas de detection d'un
-! plantage par hgardfou
-!====================================================================
+    !====================================================================
+    ! Arret du modele apres hgardfou en cas de detection d'un
+    ! plantage par hgardfou
+    !====================================================================
 
     IF (abortphy==1) THEN
